# coding: utf-8

"""
    DeepLynx

    The construction of megaprojects has consistently demonstrated challenges for project managers in regard to meeting cost, schedule, and performance requirements. Megaproject construction challenges are common place within megaprojects with many active projects in the United States failing to meet cost and schedule efforts by significant margins. Currently, engineering teams operate in siloed tools and disparate teams where connections across design, procurement, and construction systems are translated manually or over brittle point-to-point integrations. The manual nature of data exchange increases the risk of silent errors in the reactor design, with each silent error cascading across the design. These cascading errors lead to uncontrollable risk during construction, resulting in significant delays and cost overruns. DeepLynx allows for an integrated platform during design and operations of mega projects. The DeepLynx Core API delivers a few main features. 1. Provides a set of methods and endpoints for manipulating data in an object oriented database. This allows us to store complex datatypes as records and then to compile them into actual, modifiable objects at run-time. Users can store taxonomies or ontologies in a readable format. 2. Provides methods for storing and retrieving data in a graph database. This data is structured and validated against the aformentioned object oriented database before storage.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateDataSourceRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'adapter_type': 'str',
        'active': 'bool',
        'config': 'CreateDataSourceConfig'
    }

    attribute_map = {
        'name': 'name',
        'adapter_type': 'adapter_type',
        'active': 'active',
        'config': 'config'
    }

    def __init__(self, name=None, adapter_type=None, active=None, config=None):  # noqa: E501
        """CreateDataSourceRequest - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._adapter_type = None
        self._active = None
        self._config = None
        self.discriminator = None
        self.name = name
        if adapter_type is not None:
            self.adapter_type = adapter_type
        if active is not None:
            self.active = active
        if config is not None:
            self.config = config

    @property
    def name(self):
        """Gets the name of this CreateDataSourceRequest.  # noqa: E501


        :return: The name of this CreateDataSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateDataSourceRequest.


        :param name: The name of this CreateDataSourceRequest.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def adapter_type(self):
        """Gets the adapter_type of this CreateDataSourceRequest.  # noqa: E501


        :return: The adapter_type of this CreateDataSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._adapter_type

    @adapter_type.setter
    def adapter_type(self, adapter_type):
        """Sets the adapter_type of this CreateDataSourceRequest.


        :param adapter_type: The adapter_type of this CreateDataSourceRequest.  # noqa: E501
        :type: str
        """

        self._adapter_type = adapter_type

    @property
    def active(self):
        """Gets the active of this CreateDataSourceRequest.  # noqa: E501


        :return: The active of this CreateDataSourceRequest.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this CreateDataSourceRequest.


        :param active: The active of this CreateDataSourceRequest.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def config(self):
        """Gets the config of this CreateDataSourceRequest.  # noqa: E501


        :return: The config of this CreateDataSourceRequest.  # noqa: E501
        :rtype: CreateDataSourceConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this CreateDataSourceRequest.


        :param config: The config of this CreateDataSourceRequest.  # noqa: E501
        :type: CreateDataSourceConfig
        """

        self._config = config

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateDataSourceRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateDataSourceRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
