# coding: utf-8

"""
    DeepLynx

    The construction of megaprojects has consistently demonstrated challenges for project managers in regard to meeting cost, schedule, and performance requirements. Megaproject construction challenges are common place within megaprojects with many active projects in the United States failing to meet cost and schedule efforts by significant margins. Currently, engineering teams operate in siloed tools and disparate teams where connections across design, procurement, and construction systems are translated manually or over brittle point-to-point integrations. The manual nature of data exchange increases the risk of silent errors in the reactor design, with each silent error cascading across the design. These cascading errors lead to uncontrollable risk during construction, resulting in significant delays and cost overruns. DeepLynx allows for an integrated platform during design and operations of mega projects. The DeepLynx Core API delivers a few main features. 1. Provides a set of methods and endpoints for manipulating data in an object oriented database. This allows us to store complex datatypes as records and then to compile them into actual, modifiable objects at run-time. Users can store taxonomies or ontologies in a readable format. 2. Provides methods for storing and retrieving data in a graph database. This data is structured and validated against the aformentioned object oriented database before storage.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RSAResponseValueChallengeMethodsChallenges(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'method_set_id': 'str',
        'required_methods': 'list[RSAResponseValueChallengeMethodsRequiredMethods]'
    }

    attribute_map = {
        'method_set_id': 'methodSetId',
        'required_methods': 'requiredMethods'
    }

    def __init__(self, method_set_id=None, required_methods=None):  # noqa: E501
        """RSAResponseValueChallengeMethodsChallenges - a model defined in Swagger"""  # noqa: E501
        self._method_set_id = None
        self._required_methods = None
        self.discriminator = None
        if method_set_id is not None:
            self.method_set_id = method_set_id
        if required_methods is not None:
            self.required_methods = required_methods

    @property
    def method_set_id(self):
        """Gets the method_set_id of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501


        :return: The method_set_id of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501
        :rtype: str
        """
        return self._method_set_id

    @method_set_id.setter
    def method_set_id(self, method_set_id):
        """Sets the method_set_id of this RSAResponseValueChallengeMethodsChallenges.


        :param method_set_id: The method_set_id of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501
        :type: str
        """

        self._method_set_id = method_set_id

    @property
    def required_methods(self):
        """Gets the required_methods of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501


        :return: The required_methods of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501
        :rtype: list[RSAResponseValueChallengeMethodsRequiredMethods]
        """
        return self._required_methods

    @required_methods.setter
    def required_methods(self, required_methods):
        """Sets the required_methods of this RSAResponseValueChallengeMethodsChallenges.


        :param required_methods: The required_methods of this RSAResponseValueChallengeMethodsChallenges.  # noqa: E501
        :type: list[RSAResponseValueChallengeMethodsRequiredMethods]
        """

        self._required_methods = required_methods

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RSAResponseValueChallengeMethodsChallenges, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RSAResponseValueChallengeMethodsChallenges):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
